gtk3-0.15.10: Binding to the Gtk+ 3 graphical user interface library

Maintainer | gtk2hs-users@lists.sourceforge.net
Stability | provisional
Portability | portable (depends on GHC)
Safe Haskell | None
Language | Haskell98

Graphics.UI.Gtk.ActionMenuToolbar.UIManager

Contents

- Detail
  - UI Definitions
  - A UI definition
  - UI Merging
  - Accelerators
  - Smart Separators
  - Empty Menus
- Class Hierarchy
- Types
- Constructors
- Methods
- Attributes
- Signals
- Deprecated

Description

Constructing menus and toolbars from an XML description

- Module available since Gtk+ version 2.4

Synopsis

- data UIManager
- class GObjectClass o => UIManagerClass o
- castToUIManager :: GObjectClass obj => obj -> UIManager
- gTypeUIManager :: GType
- toUIManager :: UIManagerClass o => o -> UIManager
- data UIManagerItemType
  - = UiManagerAuto
  - | UiManagerMenubar
  - | UiManagerMenu
  - | UiManagerToolbar
  - | UiManagerPlaceholder
  - | UiManagerPopup
  - | UiManagerMenuitem
  - | UiManagerToolitem
  - | UiManagerSeparator
  - | UiManagerAccelerator
  - | UiManagerPopupWithAccels
- data MergeId
- uiManagerNew :: IO UIManager
- uiManagerSetAddTearoffs :: UIManager -> Bool -> IO ()
- uiManagerGetAddTearoffs :: UIManager -> IO Bool
- uiManagerInsertActionGroup :: UIManager -> ActionGroup -> Int -> IO ()
- uiManagerRemoveActionGroup :: UIManager -> ActionGroup -> IO ()
- uiManagerGetActionGroups :: UIManager -> IO [ActionGroup]
- uiManagerGetAccelGroup :: UIManager -> IO AccelGroup
- uiManagerGetWidget :: GlibString string => UIManager -> string -> IO (Maybe Widget)
- uiManagerGetToplevels :: UIManager -> [UIManagerItemType] -> IO [Widget]
- uiManagerGetAction :: GlibString string => UIManager -> string -> IO (Maybe Action)
- uiManagerAddUiFromString :: GlibString string => UIManager -> string -> IO MergeId
- uiManagerAddUiFromFile :: GlibString string => UIManager -> string -> IO MergeId
- uiManagerNewMergeId :: UIManager -> IO MergeId
- uiManagerAddUi :: GlibString string => UIManager -> MergeId -> string -> string -> Maybe string -> [UIManagerItemType] -> Bool -> IO ()
- uiManagerRemoveUi :: UIManager -> MergeId -> IO ()
- uiManagerGetUi :: GlibString string => UIManager -> IO string
- uiManagerEnsureUpdate :: UIManager -> IO ()
- uiManagerAddTearoffs :: Attr UIManager Bool
- uiManagerUi :: GlibString string => ReadAttr UIManager string
- addWidget :: UIManagerClass self => Signal self (Widget -> IO ())
- actionsChanged :: UIManagerClass self => Signal self (IO ())

# Detail

A `UIManager` constructs a user interface (menus and toolbars) from one or more UI definitions, which reference actions from one or more action groups.

## UI Definitions

The UI definitions are specified in an XML format which can be roughly described by the following DTD.

    <!ELEMENT ui (menubar|toolbar|popup|accelerator)* >
    <!ELEMENT menubar (menuitem|separator|placeholder|menu)* >
    <!ELEMENT menu (menuitem|separator|placeholder|menu)* >
    <!ELEMENT popup (menuitem|separator|placeholder|menu)* >
    <!ELEMENT toolbar (toolitem|separator|placeholder)* >
    <!ELEMENT placeholder (menuitem|toolitem|separator|placeholder|menu)* >
    <!ELEMENT menuitem EMPTY >
    <!ELEMENT toolitem EMPTY >
    <!ELEMENT separator EMPTY >
    <!ELEMENT accelerator EMPTY >
    <!ATTLIST menubar name #IMPLIED
    action #IMPLIED >
    <!ATTLIST toolbar name #IMPLIED
    action #IMPLIED >
    <!ATTLIST popup name #IMPLIED
    action #IMPLIED >
    <!ATTLIST placeholder name #IMPLIED
    action #IMPLIED
    expand (true|false) #IMPLIED >
    <!ATTLIST separator name #IMPLIED
    action #IMPLIED >
    <!ATTLIST menu name #IMPLIED
    action #REQUIRED
    position (top|bot) #IMPLIED >
    <!ATTLIST menuitem name #IMPLIED
    action #REQUIRED
    position (top|bot) #IMPLIED >
    <!ATTLIST toolitem name #IMPLIED
    action #REQUIRED
    position (top|bot) #IMPLIED >
    <!ATTLIST accelerator name #IMPLIED
    action #REQUIRED >

There are some additional restrictions beyond those specified in the DTD, e.g. every toolitem must have a toolbar in its anchestry and every menuitem must have a menubar or popup in its anchestry. Since a GMarkup parser is used to parse the UI description, it must not only be valid XML, but valid GMarkup.

If a name is not specified, it defaults to the action. If an action is not specified either, the element name is used. The name and action attributes must not contain '/' characters after parsing (since that would mess up path lookup) and must be usable as XML attributes when enclosed in doublequotes, thus they must not '"' characters or references to the &quot; entity.

## A UI definition

    <ui>
    <menubar>
    <menu name="FileMenu" action="FileMenuAction">
    <menuitem name="New" action="New2Action" />
    <placeholder name="FileMenuAdditions" />
    </menu>
    <menu name="JustifyMenu" action="JustifyMenuAction">
    <menuitem name="Left" action="justify-left"/>
    <menuitem name="Centre" action="justify-center"/>
    <menuitem name="Right" action="justify-right"/>
    <menuitem name="Fill" action="justify-fill"/>
    </menu>
    </menubar>
    <toolbar action="toolbar1">
    <placeholder name="JustifyToolItems">
    <separator/>
    <toolitem name="Left" action="justify-left"/>
    <toolitem name="Centre" action="justify-center"/>
    <toolitem name="Right" action="justify-right"/>
    <toolitem name="Fill" action="justify-fill"/>
    <separator/>
    </placeholder>
    </toolbar>
    </ui>

## UI Merging

The most remarkable feature of `UIManager` is that it can overlay a set of menuitems and toolitems over another one, and demerge them later.

Merging is done based on the names of the XML elements. Each element is identified by a path which consists of the names of its ancestors, separated by slashes. For example, the menuitem named "Left" in the example above has the path `/ui/menubar/JustifyMenu/Left` and the toolitem with the same name has path `/ui/toolbar1/JustifyToolItems/Left`.

## Accelerators

Every action has an accelerator path. Accelerators are installed together with menuitem proxies, but they can also be explicitly added with <accelerator> elements in the UI definition. This makes it possible to have accelerators for actions even if they have no visible proxies.

## Smart Separators

The separators created by `UIManager` are "smart", i.e. they do not show up in the UI unless they end up between two visible menu or tool items. Separators which are located at the very beginning or end of the menu or toolbar containing them, or multiple separators next to each other, are hidden. This is a useful feature, since the merging of UI elements from multiple sources can make it hard or impossible to determine in advance whether a separator will end up in such an unfortunate position.

For separators in toolbars, you can set `expand="true"` to turn them from a small, visible separator to an expanding, invisible one. Toolitems following an expanding separator are effectively right-aligned.

## Empty Menus

Submenus pose similar problems to separators inconnection with merging. It is impossible to know in advance whether they will end up empty after merging. `UIManager` offers two ways to treat empty submenus:

- make them disappear by hiding the menu item they're attached to
- add an insensitive "Empty" item

The behaviour is chosen based on the "hide_if_empty" property of the action to which the submenu is associated.

# Class Hierarchy

    | GObject
    | +----UIManager

# Types

data UIManager Source #

#### Instances

Instances details

Eq UIManager Source # |
Instance details Defined in Graphics.UI.Gtk.Types Methods (==) :: UIManager -> UIManager -> Bool Source # (/=) :: UIManager -> UIManager -> Bool Source #
Ord UIManager Source # |

Instance details

Defined in Graphics.UI.Gtk.Types

Methods

compare :: UIManager -> UIManager -> Ordering Source #

(<) :: UIManager -> UIManager -> Bool Source #

(<=) :: UIManager -> UIManager -> Bool Source #

(>) :: UIManager -> UIManager -> Bool Source #

(>=) :: UIManager -> UIManager -> Bool Source #

max :: UIManager -> UIManager -> UIManager Source #

min :: UIManager -> UIManager -> UIManager Source #

GObjectClass UIManager Source # |
Instance details Defined in Graphics.UI.Gtk.Types Methods toGObject :: UIManager -> GObject Source # unsafeCastGObject :: GObject -> UIManager Source #
UIManagerClass UIManager Source # |
Instance details Defined in Graphics.UI.Gtk.Types

class GObjectClass o => UIManagerClass o Source #

#### Instances

Instances details

UIManagerClass UIManager Source # |
Instance details Defined in Graphics.UI.Gtk.Types

castToUIManager :: GObjectClass obj => obj -> UIManager Source #

gTypeUIManager :: GType Source #

toUIManager :: UIManagerClass o => o -> UIManager Source #

data UIManagerItemType Source #

These enumeration values are used by `uiManagerAddUi` to determine what UI element to create.

Constructors

UiManagerAuto |
UiManagerMenubar |
UiManagerMenu |
UiManagerToolbar |
UiManagerPlaceholder |
UiManagerPopup |
UiManagerMenuitem |
UiManagerToolitem |
UiManagerSeparator |
UiManagerAccelerator |
UiManagerPopupWithAccels |

#### Instances

Instances details

Bounded UIManagerItemType Source # |
Instance details Defined in Graphics.UI.Gtk.ActionMenuToolbar.UIManager Methods minBound :: UIManagerItemType Source # maxBound :: UIManagerItemType Source #
Enum UIManagerItemType Source # |

Instance details

Defined in Graphics.UI.Gtk.ActionMenuToolbar.UIManager

Methods

succ :: UIManagerItemType -> UIManagerItemType Source #

pred :: UIManagerItemType -> UIManagerItemType Source #

toEnum :: Int -> UIManagerItemType Source #

fromEnum :: UIManagerItemType -> Int Source #

enumFrom :: UIManagerItemType -> [UIManagerItemType] Source #

enumFromThen :: UIManagerItemType -> UIManagerItemType -> [UIManagerItemType] Source #

enumFromTo :: UIManagerItemType -> UIManagerItemType -> [UIManagerItemType] Source #

enumFromThenTo :: UIManagerItemType -> UIManagerItemType -> UIManagerItemType -> [UIManagerItemType] Source #

Flags UIManagerItemType Source # |
Instance details Defined in Graphics.UI.Gtk.ActionMenuToolbar.UIManager

data MergeId Source #

# Constructors

uiManagerNew :: IO UIManager Source #

Creates a new ui manager object.

# Methods

uiManagerSetAddTearoffs Source #

Arguments

:: UIManager |
-> Bool | `addTearoffs` - whether tearoff menu items are added
-> IO () |

Sets the "add_tearoffs" property, which controls whether menus generated by this `UIManager` will have tearoff menu items.

Note that this only affects regular menus. Generated popup menus never have tearoff menu items.

uiManagerGetAddTearoffs Source #

Arguments

:: UIManager |
-> IO Bool | returns whether tearoff menu items are added

Returns whether menus generated by this `UIManager` will have tearoff menu items.

uiManagerInsertActionGroup Source #

Arguments

:: UIManager |
-> ActionGroup | `actionGroup` - the action group to be inserted
-> Int | `pos` - the position at which the group will be inserted.
-> IO () |

Inserts an action group into the list of action groups associated with `self`. Actions in earlier groups hide actions with the same name in later groups.

uiManagerRemoveActionGroup Source #

Arguments

:: UIManager |
-> ActionGroup | `actionGroup` - the action group to be removed
-> IO () |

Removes an action group from the list of action groups associated with `self`.

uiManagerGetActionGroups :: UIManager -> IO [ActionGroup] Source #

Returns the list of action groups associated with the UI manager.

uiManagerGetAccelGroup Source #

Arguments

:: UIManager |
-> IO AccelGroup | returns the `AccelGroup`.

Returns the `AccelGroup` associated with `self`.

uiManagerGetWidget Source #

Arguments

:: GlibString string |
=> UIManager |
-> string | `path` - a path
-> IO (Maybe Widget) | returns the widget found by following the path, or `Nothing` if no widget was found.

Looks up a widget by following a path. The path consists of the names specified in the XML description of the UI. separated by '/'. Elements which don't have a name or action attribute in the XML (e.g. <popup>) can be addressed by their XML element name (e.g. "popup"). The root element ("/ui") can be omitted in the path.

Note that the widget found by following a path that ends in a <menu> element is the menuitem to which the menu is attached, not the menu itself.

uiManagerGetToplevels Source #

Arguments

:: UIManager |
-> [UIManagerItemType] | `types` - specifies the types of toplevel widgets to include. Allowed types are `UiManagerMenubar`, `UiManagerToolbar` and `UiManagerPopup`.
-> IO [Widget] | returns a list of all toplevel widgets of the requested types.

Obtains a list of all toplevel widgets of the requested types.

uiManagerGetAction Source #

Arguments

:: GlibString string |
=> UIManager |
-> string | `path` - a path
-> IO (Maybe Action) | returns the action whose proxy widget is found by following the path, or `Nothing` if no widget was found.

Looks up an action by following a path. See `uiManagerGetWidget` for more information about paths.

uiManagerAddUiFromString Source #

Arguments

:: GlibString string |
=> UIManager |
-> string | `buffer` - the string to parse
-> IO MergeId | returns The merge id for the merged UI. The merge id can be used to unmerge the UI with `uiManagerRemoveUi`.

Parses a string containing a UI definition and merges it with the current contents of `self`. An enclosing <ui> element is added if it is missing.

If a parse error occurres, an exception is thrown.

uiManagerAddUiFromFile Source #

Arguments

:: GlibString string |
=> UIManager |
-> string | `filename` - the name of the file to parse
-> IO MergeId | returns The merge id for the merged UI. The merge id can be used to unmerge the UI with `uiManagerRemoveUi`.

Parses a file containing a UI definition and merges it with the current contents of `self`.

If a parse or IO error occurres, an exception is thrown.

uiManagerNewMergeId :: UIManager -> IO MergeId Source #

Returns an unused merge id, suitable for use with `uiManagerAddUi`.

uiManagerAddUi Source #

Arguments

:: GlibString string |
=> UIManager |
-> MergeId | `mergeId` - the merge id for the merged UI, see `uiManagerNewMergeId`
-> string | `path` - a path
-> string | `name` - the name for the added UI element
-> Maybe string | `action` - the name of the action to be proxied, or `Nothing` to add a separator
-> [UIManagerItemType] | `type` - the type of UI element to add.
-> Bool | `top` - if `True`, the UI element is added before its siblings, otherwise it is added after its siblings.
-> IO () |

Adds a UI element to the current contents of `self`.

If `type` is `UiManagerAuto`, Gtk+ inserts a menuitem, toolitem or separator if such an element can be inserted at the place determined by `path`. Otherwise `type` must indicate an element that can be inserted at the place determined by `path`.

If `path` points to a menuitem or toolitem, the new element will be inserted before or after this item, depending on `top`.

uiManagerRemoveUi Source #

Arguments

:: UIManager |
-> MergeId | `mergeId` - a merge id as returned by `uiManagerAddUiFromString`
-> IO () |

Unmerges the part of the UI manager's content identified by `mergeId`.

uiManagerGetUi Source #

Arguments

:: GlibString string |
=> UIManager |
-> IO string | returns string containing an XML representation of the merged UI.

Creates a UI definition of the merged UI.

uiManagerEnsureUpdate :: UIManager -> IO () Source #

Makes sure that all pending updates to the UI have been completed.

This may occasionally be necessary, since `UIManager` updates the UI in an idle function. A typical example where this function is useful is to enforce that the menubar and toolbar have been added to the main window before showing it:

    do
    containerAdd window vbox
    onAddWidget merge (addWidget vbox)
    uiManagerAddUiFromFile merge "my-menus"
    uiManagerAddUiFromFile merge "my-toolbars"
    uiManagerEnsureUpdate merge
    widgetShow window

# Attributes

uiManagerAddTearoffs :: Attr UIManager Bool Source #

The "add-tearoffs" property controls whether generated menus have tearoff menu items.

Note that this only affects regular menus. Generated popup menus never have tearoff menu items.

Default value: `False`

uiManagerUi :: GlibString string => ReadAttr UIManager string Source #

An XML string describing the merged UI.

Default value: `"<ui>\n</ui>\n"`

# Signals

addWidget :: UIManagerClass self => Signal self (Widget -> IO ()) Source #

The add_widget signal is emitted for each generated menubar and toolbar. It is not emitted for generated popup menus, which can be obtained by `uiManagerGetWidget`.

actionsChanged :: UIManagerClass self => Signal self (IO ()) Source #

The "actions-changed" signal is emitted whenever the set of actions changes.

# Deprecated